<template>
  <section id="index" class="animate__animated animate__fadeIn animate__faster">
    <MainBanner />

    <LocalLoader v-if="loading" />

    <section id="products-container" v-else>
      <ProductsList
        title="Nuestros productos"
        :products="products"
        :filters="true"
      />
    </section>

    <div class="d-flex justify-content-center mt-3">
      <b-pagination
        v-model="page"
        :total-rows="nroItems"
        :per-page="number_paginate"
        @change="paginate($event)"
        v-if="products.length && nroItems > number_paginate"
      ></b-pagination>
    </div>

    <ModalFilters
      :loading="loadingFilter"
      @filter="filter($event)"
      @cleanUp="cleanUp()"
    />
  </section>
</template>

<script>
import { appConfig } from "@/app-config.js";

import GetProductos from "@/graphql/queries/productos/GetProductos.gql";
import GetBusquedaAvanzada from "@/graphql/queries/productos/GetBusquedaAvanzada.gql";

import LocalLoader from "@/components/global/loaders/LocalLoader"
import MainBanner from "@/components/banner/MainBanner";
import ProductsList from "@/components/products/ProductsList";
import ModalFilters from "@/components/products/ModalFilters";

export default {
  name: "IndexPage",
  data() {
    return {
      appConfig,
      number_paginate: appConfig.pagination.number_paginate,
      page: 1,
      nroItems: 0,
      products: [],
      loading: false,
      loadingFilter: false,
      dataToFilter: null,
      filterStatus: false,
    };
  },
  head() {
    let title = appConfig.openGraph.titulo,
      description = appConfig.openGraph.descripcion,
      logo = appConfig.openGraph.logo,
      url = appConfig.openGraph.urlWeb,
      whatsappImg = appConfig.openGraph.logoWhatsapp,
      keywords = appConfig.openGraph.keywords;

    return {
      title,
      meta: [
        { hid: "k", name: "keywords", content: keywords },

        // Facebook OpenGraph
        { hid: 'fu', property: "og:url", content: url },
        { hid: 'ft', property: "og:title", content: title },
        { hid: 'fsn', property: "og:site_name", content: title },
        { hid: 'fty', property: "og:type", content: "website" },
        { hid: 'fi', property: "og:image", content: logo },
        { hid: 'fd', property: "og:description", content: description },

        // Whatsapp OpenGraph
        { hid: 'wu', property: "og:url", content: url },
        { hid: 'wt', property: "og:title", content: title },
        { hid: 'wsn', property: "og:site_name", content: title },
        { hid: 'wty', property: "og:type", content: "website" },
        { hid: 'wi', property: "og:image", content: whatsappImg },
        { hid: 'wd', property: "og:description", content: description },

        // Twitter Card
        { name: "twitter:card", content: "summary" },
        { name: "twitter:title", content: title },
        { name: "twitter:description", content: description },
        { name: "twitter:image", content: logo },
      ],
    };
  },
  async created() {
    if (this.$route.query.p) {
      this.page = this.$route.query.p;
    }

    this.products = await this.getProducts();
  },
  components: {
    MainBanner,
    ProductsList,
    ModalFilters,
    LocalLoader
  },
  methods: {
    async getProducts() {
      this.loading = true

      let response = await this.$apollo.query({
        query: GetProductos,
        variables: {
          number_paginate: this.number_paginate,
          page: this.page,
          estado: ""
        },
        fetchPolicy: "no-cache",
      });

      this.nroItems = response.data.GetProductos.NroItems;

      this.$store.commit("SET_LOADER", false);

      this.loading = false

      return response.data.GetProductos.data;
    },
    async paginate(event) {
      this.page = event;

      this.$router.push({ name: this.$route.name, query: { p: event } });

      if (this.filterStatus) {
        this.products = await this.getProductsByFilter();
      } else {
        this.products = await this.getProducts();
      }

      this.scrollTo();
    },
    async filter(event) {
      this.loadingFilter = true;

      this.dataToFilter = event;

      this.page = 1;
      this.$router.push({
        name: this.$route.name,
        params: this.$route.params,
        query: { p: 1 },
      });

      this.products = await this.getProductsByFilter();

      this.scrollTo();

      this.$bvModal.hide("modal-filters");
    },
    async cleanUp() {
      this.filterStatus = false;

      this.page = 1;
      this.$router.push({
        name: this.$route.name,
        params: this.$route.params,
        query: { p: 1 },
      });

      this.products = await this.getProducts();

      this.scrollTo();

      this.$bvModal.hide("modal-filters");
    },
    async getProductsByFilter() {
      let res = await this.$apollo.query({
        query: GetBusquedaAvanzada,
        variables: {
          number_paginate: this.number_paginate,
          page: this.page,
          precio: this.dataToFilter.precio,
          tipoOrdenacion: parseInt(this.dataToFilter.tipoOrdenacion),
          categoria_slug: this.dataToFilter.categoria_slug,
          tipoFavorito: this.dataToFilter.tipoFavorito
        },
        fetchPolicy: "no-cache",
      });

      this.nroItems = res.data.GetBusquedaAvanzada.NroItems;

      this.loadingFilter = false;
      this.filterStatus = true;

      return res.data.GetBusquedaAvanzada.data;
    },
    scrollTo() {
      const elemento = document.getElementById("products-container");

      this.$smoothScroll({
        offset: -100,
        scrollTo: elemento,
        updateHistory: false,
      });
    },
    // async infiniteScroll() {
    //   window.onscroll = async () => {
    //     // True || False
    //     let bottomOfWindow =
    //       document.documentElement.scrollTop + window.innerHeight ===
    //       document.documentElement.offsetHeight;

    //     if (bottomOfWindow) {
    //       // Preguntamos si la página actual es menor al total de páginas la Api
    //       if (this.page < this.nroItems / this.number_paginate) {
    //         // Si es así, aumentamos la página actual en 1
    //         // importante asignarle el signo < ya que si es igual o mayor, entonces
    //         // se le sumará 1 y la api devolverá un error
    //         this.page = this.page + 1;

    //         let newProducts = await this.getProducts();

    //         this.products.push(...newProducts);

    //         // Y hacemos el pedido de los nuevos datos
    //         // if (this.filtrando) {
    //         //   this.getProductsByFilter().then((products) => {
    //         //     products.forEach((item) => this.products.push(item));
    //         //   });
    //         // } else {
    //         //   this.getProductosDestacados().then((products) => {
    //         //     products.forEach((item) => this.products.push(item));
    //         //   });
    //         // }
    //       }
    //     }
    //   };
    // }
  },
};
</script>
